Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 1975)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 1976)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! -----------------
-! 
+! Parts of the code have been reformatted. Use of radiation model output is
+! generalized and simplified. Added more output quantities due to modularization
 ! 
 ! Former revisions:
@@ -178,13 +179,7 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  force_radiation_call, radiation_scheme, rad_net, rad_sw_in,     &
-               rad_lw_out, rad_lw_out_change_0, sigma_sb,                      &
-               unscheduled_radiation_calls
+        ONLY:  force_radiation_call, rad_net, rad_sw_in, rad_lw_out,           &
+               rad_lw_out_change_0, unscheduled_radiation_calls
         
-#if defined ( __rrtmg )
-    USE radiation_model_mod,                                                   &
-        ONLY:  rrtm_idrv
-#endif
-
     USE statistics,                                                            &
         ONLY:  hom, statistic_regions
@@ -636,5 +631,4 @@
     END INTERFACE lsm_read_restart_data
 
-
     INTERFACE lsm_last_actions
        MODULE PROCEDURE lsm_last_actions
@@ -648,200 +642,206 @@
 !> Check data output for land surface model
 !------------------------------------------------------------------------------!
-    SUBROUTINE lsm_check_data_output( var, unit, i, ilen, k )
+ SUBROUTINE lsm_check_data_output( var, unit, i, ilen, k )
  
  
-       USE control_parameters,                                                 &
-           ONLY: data_output, message_string
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  unit     !< 
-       CHARACTER (LEN=*) ::  var !<
-
-       INTEGER(iwp) :: i
-       INTEGER(iwp) :: ilen   
-       INTEGER(iwp) :: k
-
-       SELECT CASE ( TRIM( var ) )
-
-          CASE ( 'm_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'm3/m3'
+    USE control_parameters,                                                 &
+        ONLY:  data_output, message_string
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*) ::  unit     !< 
+    CHARACTER (LEN=*) ::  var !<
+
+    INTEGER(iwp) :: i
+    INTEGER(iwp) :: ilen   
+    INTEGER(iwp) :: k
+
+    SELECT CASE ( TRIM( var ) )
+
+       CASE ( 'm_soil' )
+          IF (  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                      'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          unit = 'm3/m3'
+           
+       CASE ( 't_soil' )
+          IF (  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                      'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          unit = 'K'   
              
-          CASE ( 't_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                         'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'K'   
+       CASE ( 'lai*', 'c_liq*', 'c_soil*', 'c_veg*', 'ghf_eb*', 'm_liq_eb*',&
+              'qsws_eb*', 'qsws_liq_eb*', 'qsws_soil_eb*', 'qsws_veg_eb*',  &
+              'r_a*', 'r_s*', 'shf_eb*' )
+          IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
+             message_string = 'illegal value for data_output: "' //         &
+                              TRIM( var ) // '" & only 2d-horizontal ' //   &
+                              'cross sections are allowed for this value'
+             CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'lai*'  .AND.  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'c_liq*'  .AND.  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'c_soil*'  .AND.  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'c_veg*'  .AND.  .NOT. land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'ghf_eb*'  .AND.  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'm_liq_eb*'  .AND.  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'qsws_eb*'  .AND.  .NOT.  land_surface )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'qsws_liq_eb*'  .AND.  .NOT. land_surface )   &
+          THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'qsws_soil_eb*'  .AND.  .NOT.  land_surface ) &
+          THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'qsws_veg_eb*'  .AND.  .NOT. land_surface )   &
+          THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'r_a*'  .AND.  .NOT.  land_surface ) &
+          THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( TRIM( var ) == 'r_s*'  .AND.  .NOT.  land_surface ) &
+          THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
+                              'res land_surface = .TRUE.'
+             CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          IF ( TRIM( var ) == 'lai*'   )  unit = 'none' 
+          IF ( TRIM( var ) == 'c_liq*' )  unit = 'none'
+          IF ( TRIM( var ) == 'c_soil*')  unit = 'none'
+          IF ( TRIM( var ) == 'c_veg*' )  unit = 'none'
+          IF ( TRIM( var ) == 'ghf_eb*')  unit = 'W/m2'
+          IF ( TRIM( var ) == 'm_liq_eb*'     )  unit = 'm'
+          IF ( TRIM( var ) == 'qsws_eb*'      ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'qsws_liq_eb*'  ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'qsws_soil_eb*' ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'qsws_veg_eb*'  ) unit = 'W/m2'
+          IF ( TRIM( var ) == 'r_a*')     unit = 's/m'     
+          IF ( TRIM( var ) == 'r_s*')     unit = 's/m' 
+          IF ( TRIM( var ) == 'shf_eb*')  unit = 'W/m2'
              
-          CASE ( 'lai*', 'c_liq*', 'c_soil*', 'c_veg*', 'ghf_eb*', 'm_liq_eb*',&
-                 'qsws_eb*', 'qsws_liq_eb*', 'qsws_soil_eb*', 'qsws_veg_eb*',  &
-                 'r_a*', 'r_s*', 'shf_eb*' )
-             IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
-                message_string = 'illegal value for data_output: "' //         &
-                                 TRIM( var ) // '" & only 2d-horizontal ' //   &
-                                 'cross sections are allowed for this value'
-                CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'lai*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'c_liq*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'c_soil*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'c_veg*'  .AND.  .NOT. land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0401', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'ghf_eb*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'm_liq_eb*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_eb*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_liq_eb*'  .AND.  .NOT. land_surface )   &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_soil_eb*'  .AND.  .NOT.  land_surface ) &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'qsws_veg_eb*'  .AND.  .NOT. land_surface )   &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'r_a*'  .AND.  .NOT.  land_surface ) &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'r_s*'  .AND.  .NOT.  land_surface ) &
-             THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
-
-             IF ( TRIM( var ) == 'lai*'   )  unit = 'none' 
-             IF ( TRIM( var ) == 'c_liq*' )  unit = 'none'
-             IF ( TRIM( var ) == 'c_soil*')  unit = 'none'
-             IF ( TRIM( var ) == 'c_veg*' )  unit = 'none'
-             IF ( TRIM( var ) == 'ghf_eb*')  unit = 'W/m2'
-             IF ( TRIM( var ) == 'm_liq_eb*'     )  unit = 'm'
-             IF ( TRIM( var ) == 'qsws_eb*'      ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'qsws_liq_eb*'  ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'qsws_soil_eb*' ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'qsws_veg_eb*'  ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'r_a*')     unit = 's/m'     
-             IF ( TRIM( var ) == 'r_s*')     unit = 's/m' 
-             IF ( TRIM( var ) == 'shf_eb*')  unit = 'W/m2'
-             
-          CASE DEFAULT
-             unit = 'illegal'
-
-       END SELECT
-
-
-    END SUBROUTINE lsm_check_data_output
-
+       CASE DEFAULT
+          unit = 'illegal'
+
+    END SELECT
+
+
+ END SUBROUTINE lsm_check_data_output
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Check data output of profiles for land surface model
+!------------------------------------------------------------------------------!
  SUBROUTINE lsm_check_data_output_pr( variable, var_count, unit, dopr_unit )
  
-       USE control_parameters,                                                 &
-           ONLY: data_output_pr, message_string
-
-       USE indices
-
-       USE profil_parameter
-
-       USE statistics
-
-       IMPLICIT NONE
+    USE control_parameters,                                                 &
+        ONLY:  data_output_pr, message_string
+
+    USE indices
+
+    USE profil_parameter
+
+    USE statistics
+
+    IMPLICIT NONE
    
-       CHARACTER (LEN=*) ::  unit      !< 
-       CHARACTER (LEN=*) ::  variable  !< 
-       CHARACTER (LEN=*) ::  dopr_unit !< local value of dopr_unit
+    CHARACTER (LEN=*) ::  unit      !< 
+    CHARACTER (LEN=*) ::  variable  !< 
+    CHARACTER (LEN=*) ::  dopr_unit !< local value of dopr_unit
  
-       INTEGER(iwp) ::  user_pr_index !< 
-       INTEGER(iwp) ::  var_count     !< 
-
-       SELECT CASE ( TRIM( variable ) )
+    INTEGER(iwp) ::  user_pr_index !< 
+    INTEGER(iwp) ::  var_count     !< 
+
+    SELECT CASE ( TRIM( variable ) )
        
-          CASE ( 't_soil', '#t_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) // ' is' // &
-                                 'not implemented for land_surface = .FALSE.'
-                CALL message( 'check_parameters', 'PA0402', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(var_count) = 89
-                dopr_unit     = 'K'
-                hom(0:nzs-1,2,89,:)  = SPREAD( - zs, 2, statistic_regions+1 )
-                IF ( data_output_pr(var_count)(1:1) == '#' )  THEN
-                   dopr_initial_index(var_count) = 90
-                   hom(0:nzs-1,2,90,:)   = SPREAD( - zs, 2, statistic_regions+1 )
-                   data_output_pr(var_count)     = data_output_pr(var_count)(2:)
-                ENDIF
-                unit = dopr_unit
+       CASE ( 't_soil', '#t_soil' )
+          IF (  .NOT.  land_surface )  THEN
+             message_string = 'data_output_pr = ' //                        &
+                              TRIM( data_output_pr(var_count) ) // ' is' // &
+                              'not implemented for land_surface = .FALSE.'
+             CALL message( 'check_parameters', 'PA0402', 1, 2, 0, 6, 0 )
+          ELSE
+             dopr_index(var_count) = 89
+             dopr_unit     = 'K'
+             hom(0:nzs-1,2,89,:)  = SPREAD( - zs, 2, statistic_regions+1 )
+             IF ( data_output_pr(var_count)(1:1) == '#' )  THEN
+                dopr_initial_index(var_count) = 90
+                hom(0:nzs-1,2,90,:)   = SPREAD( - zs, 2, statistic_regions+1 )
+                data_output_pr(var_count)     = data_output_pr(var_count)(2:)
              ENDIF
-
-          CASE ( 'm_soil', '#m_soil' )
-             IF (  .NOT.  land_surface )  THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(var_count) ) // ' is' // &
-                                 ' not implemented for land_surface = .FALSE.'
-                CALL message( 'check_parameters', 'PA0402', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(var_count) = 91
-                dopr_unit     = 'm3/m3'
-                hom(0:nzs-1,2,91,:)  = SPREAD( - zs, 2, statistic_regions+1 )
-                IF ( data_output_pr(var_count)(1:1) == '#' )  THEN
-                   dopr_initial_index(var_count) = 92
-                   hom(0:nzs-1,2,92,:)   = SPREAD( - zs, 2, statistic_regions+1 )
-                   data_output_pr(var_count)     = data_output_pr(var_count)(2:)
-                ENDIF
-                 unit = dopr_unit
+             unit = dopr_unit
+          ENDIF
+
+       CASE ( 'm_soil', '#m_soil' )
+          IF (  .NOT.  land_surface )  THEN
+             message_string = 'data_output_pr = ' //                        &
+                              TRIM( data_output_pr(var_count) ) // ' is' // &
+                              ' not implemented for land_surface = .FALSE.'
+             CALL message( 'check_parameters', 'PA0402', 1, 2, 0, 6, 0 )
+          ELSE
+             dopr_index(var_count) = 91
+             dopr_unit     = 'm3/m3'
+             hom(0:nzs-1,2,91,:)  = SPREAD( - zs, 2, statistic_regions+1 )
+             IF ( data_output_pr(var_count)(1:1) == '#' )  THEN
+                dopr_initial_index(var_count) = 92
+                hom(0:nzs-1,2,92,:)   = SPREAD( - zs, 2, statistic_regions+1 )
+                data_output_pr(var_count)     = data_output_pr(var_count)(2:)
              ENDIF
-
-
-          CASE DEFAULT
-             unit = 'illegal'
-
-       END SELECT
-
-
-    END SUBROUTINE lsm_check_data_output_pr
+             unit = dopr_unit
+          ENDIF
+
+
+       CASE DEFAULT
+          unit = 'illegal'
+
+    END SELECT
+
+
+ END SUBROUTINE lsm_check_data_output_pr
  
  
